<?php
/**
 * @package n3tTemplate
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2011 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.html.pane');
jimport('joomla.application.module.helper'); 
jimport('joomla.version');

class n3tTemplateHelperHTML extends JObject
{
	/**
	 * Render the CPanel icon
	 *
	 */
	function cpanelIcon( $link, $image, $text )
	{
		$app = &JFactory::getApplication();
		$lang		=& JFactory::getLanguage();
		$template	= $app->getTemplate();
		?>
		<div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
			<div class="icon">
				<a href="<?php echo $link; ?>">
          <img src="<?php echo JURI::root(true).'/media/com_n3ttemplate/images/icon-48-'.$image.'.png'; ?>" alt="<?php echo $text; ?>" title="<?php echo $text; ?>" />
					<span><?php echo $text; ?></span></a>
			</div>
		</div>
		<?php
	}
  
	/**
	 * Render the CPanel icons
	 *
	 */
  function cpanelIcons($icons) 
  {
    foreach($icons as $text=>$iconGroup) 
    {
		?>
	<h3 class="cpanelIconsHeader"><?php echo JText::_('COM_N3TTEMPLATE_CPANEL_'.$text)?></h3>	
	<div class="cpanelIcons">
		<?php
		  foreach($iconGroup as $icon) 
      {
        $link = JURI::base().'index.php?option='.JRequest::getCmd('option').($icon['view'] ? '&view='.$icon['view'] : '').($icon['task'] ? '&task='.$icon['task'] : '').$icon['params'];
        n3tTemplateHelperHTML::cpanelIcon($link,$icon['icon'],$icon['text']);
      }
		?>
	</div>
	<div class="clr"></div>
		<?php                  
    }
  }
  
	function cpanelModules()
	{	
		$modules = &JModuleHelper::getModules('n3ttemplate.cpanel');
		$pane = &JPane::getInstance('sliders', array('allowAllClose' => true));
		echo $pane->startPane("content-pane");

		foreach ($modules as $module) {
			$title = $module->title ;
			echo $pane->startPanel( $title, 'cpanel-panel-'.$module->name );
			echo JModuleHelper::renderModule($module);
			echo $pane->endPanel();
		}

		echo $pane->endPane();
	}   	 

  function _getTitle($table, $id)
  {
    $db	=& JFactory::getDBO(); 
    $db->setQuery('SELECT title FROM #__n3ttemplate_'.$table.' WHERE id='.$id);
		return $db->loadResult();
  }

  function _globalTitle()
  {
    if (JRequest::getInt('hidemainmenu',0) == 0)
      return '<a href="'.JURI::base().'index.php?option='.JRequest::getCmd('option').'">n3tTemplate</a>';
    else
      return 'n3tTemplate';
  }

  function _categoryTitle()
  {
		$app=JFactory::getApplication();
		$option=JRequest::getCmd('option');
		
    $category_id=$app->getUserStateFromRequest($option.'.category_id','category_id',0,'int');
    
    if ($category_id) {
      if (JRequest::getInt('hidemainmenu',0) == 0)
        return '<a href="'.JURI::base().'index.php?option='.JRequest::getCmd('option').'&view=categories">'.n3tTemplateHelperHTML::_getTitle('categories',$category_id).'</a>';
      else
        return n3tTemplateHelperHTML::_getTitle('categories',$category_id);
    } else 
      return JText::_('COM_N3TTEMPLATE_ALL_CATEGORIES');
  }

  function toolbarTitle($text = false) 
  {
    $title = array();
    $view=JRequest::getCmd('view');
    $title[] = n3tTemplateHelperHTML::_globalTitle();
    $title[] = '<small>'.$text.'</small>';
     
    JToolBarHelper::title(implode(' - ',$title),'n3ttemplate');
  }
    
  function subtoolbar() 
  {
    JSubMenuHelper::addEntry(JText::_('COM_N3TTEMPLATE_CONTROL_PANEL'), JURI::base().'index.php?option='.JRequest::getCmd('option'));
    if (n3tTemplateHelperACL::authorizeAdmin()) {        
      JSubMenuHelper::addEntry(JText::_('COM_N3TTEMPLATE_CATEGORIES'), JURI::base().'index.php?option='.JRequest::getCmd('option').'&view=categories');    
      JSubMenuHelper::addEntry(JText::_('COM_N3TTEMPLATE_TEMPLATES'), JURI::base().'index.php?option='.JRequest::getCmd('option').'&view=templates');
    }    
  }  
  
  function assets() 
  {
    $app=& JFactory::getApplication();
		$doc=& JFactory::getDocument();		
	  $doc->addStyleSheet(JURI::root(true).'/media/com_n3ttemplate/n3ttemplate.css');
  }

  function assetsPopup() 
  {
    $app=& JFactory::getApplication();
		$doc=& JFactory::getDocument();		
	  $doc->addStyleSheet(JURI::root(true).'/media/com_n3ttemplate/n3ttemplate.popup.css');
  }

	function categoryTree( $id, $fieldname, $excludeid = null, $size = 10, $autosubmit = false, $alltext = false )
	{
		$db =& JFactory::getDBO();

		if ( $excludeid ) {
			$excludeid = ' AND id != '.(int) $excludeid;
		} else {
			$excludeid = null;
		}

		if (!$id) $id = 0;

		$query = 'SELECT *, title AS name, parent_id AS parent' .
				' FROM #__n3ttemplate_categories c' .
				' WHERE published != -2' .
				$excludeid .
				' ORDER BY parent_id, ordering';
		$db->setQuery( $query );
		$items = $db->loadObjectList();

		$children = array();

		if ( $items )
		{
			foreach ( $items as $v )
			{			  
				$pt 	= $v->parent_id;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}

		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );

		$items 	= array();
		if ($alltext) $items[] = JHTML::_('select.option',  '-1', $alltext );
		$items[] = JHTML::_('select.option',  '0', JText::_( 'COM_N3TTEMPLATE_UNCATEGORIZED' ) );

		foreach ( $list as $item ) {
      if (JVersion::isCompatible('1.6.0'))
        // Joomla 1.6.0 bug #24973
			  $items[] = JHTML::_('select.option',  $item->id, html_entity_decode($item->treename, ENT_COMPAT, 'UTF-8') );
      else
			  $items[] = JHTML::_('select.option',  $item->id, $item->treename );
		}
    
    if ($autosubmit) $autosubmit = ' onchange="this.form.submit();"';
		$output = JHTML::_('select.genericlist',   $items, $fieldname, 'class="inputbox" size="'.$size.'"'.$autosubmit, 'value', 'text', $id );

		return $output;
	}
	
	function booleanList( $name, $value = null, $id = null ) {
		$arr = array(
			JHTML::_('select.option', '0', JText::_('COM_N3TTEMPLATE_NO')),
			JHTML::_('select.option', '1', JText::_('COM_N3TTEMPLATE_YES'))
		);
		return JHTML::_('select.genericlist',  $arr, $name, 'class="inputbox" size="1"', 'value', 'text', (int)$value, $id );
	}

  function filterState($filter_state) {
    $states = array();
    $states[]=JHTML::_('select.option',2,JText::_('COM_N3TTEMPLATE_FILTER_CURRENT'),'id','title');
    $states[]=JHTML::_('select.option',1,JText::_('COM_N3TTEMPLATE_FILTER_PUBLISHED'),'id','title');
    $states[]=JHTML::_('select.option',0,JText::_('COM_N3TTEMPLATE_FILTER_UNPUBLISHED'),'id','title');
    $states[]=JHTML::_('select.option',-2,JText::_('COM_N3TTEMPLATE_FILTER_TRASHED'),'id','title');
    return JHTML::_('select.genericlist',$states,'filter_state','class="inputbox" size="1" onchange="this.form.submit();"','id','title',$filter_state);    
  }
  
  function displayAccess(&$row, $i) {
		$color_access = '';
    if (!JVersion::isCompatible('1.6.0')) {    
  		if ( !$row->access )  {
  			$color_access = ' style="color: green;"';
  		} else if ( $row->access == 1 ) {
  			$color_access = ' style="color: red;"';
  		} else {
  			$color_access = ' style="color: black;"';
  		}
		}

		return '<span'. $color_access .'>'. JText::_( $row->groupname ) .'</span>';
  }
    
}
?>